#include "gray.h"

namespace genetic {
void GrayCode::binToGray(const std::vector<int>& binCode, std::vector<int> &grayCode) {
	//"""Binarno število pretvori v grejev kod"""
	int m=(int)binCode.size();
	if (m==0) return;
	grayCode.resize(m);
	grayCode[0]=binCode[0];
	for (int i=1; i < m;i++)
		grayCode[i]=binCode[i-1] xor binCode[i];
}
	
void GrayCode::grayToBin(const std::vector<int>& grayCode, std::vector<int> &binCode) {
	//"""Grayev kod pretvori v binarno število"""
	int m=(int)grayCode.size();
	if (m==0) return;
	int val=grayCode[0];
	binCode.resize(m);
	binCode[0]=val;
	for (int i=1; i < m; i++) {
		if (grayCode[i]==1)
			val=val==0?1:0;
		binCode[i]=val;
	}
}
}
