/***************************************************************************
 *   Copyright (C) 2005 by Aleš Zamuda   *
 *   ales.zamuda@uni-mb.si   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GENETICSCHEMECALCULATOR_H
#define GENETICSCHEMECALCULATOR_H

#include <vector>

namespace genetic {
	class Osebek;

	/**
	Iz podanih podatkov izračuna podatke za shemo.
	 
	@author Aleš Zamuda
	*/
	class SchemeCalculator {
	public:
		SchemeCalculator(const std::vector<int> &shema,
						 const std::vector<Osebek*> &osebki);
		~SchemeCalculator();

		void SchemeCalculator::izracunaj(double F, int pop_size, float p_k, int m, double p_m);

		double getFPovprecni();
		double getEvalS0t();
		int getDolzinaSheme();
		int getRedSheme();
		int getStPripadajocihS0();
		double getKolicnikSheme();
		double getNapovedZaShemoS0t1();
		
	private:
		int SchemeCalculator::racunajRedSheme();
		int SchemeCalculator::racunajDolzinoSheme();
		double SchemeCalculator::oceneSheme();
		int SchemeCalculator::steviloPripadajocih();

		const std::vector<int> &shema;
		const std::vector<Osebek*> &osebki;

		double fPovprecni;
		double evalS0t;
		int dolzinaSheme;
		int redSheme;
		int stPripadajocihS0;
		double kolicnikSheme;
		double napovedZaShemoS0t1;
	};

}


#endif
