/***************************************************************************
 *   Copyright (C) 2005 by Aleš Zamuda   *
 *   ales.zamuda@uni-mb.si   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GENETICSELECTION_H
#define GENETICSELECTION_H
#include <vector>

namespace genetic {
	class Populacija;
	class Osebek;
	namespace selection {

		/**
		Je nadrazred za selekcijo. Izbiramo lahko izmed več selekcij.
		Z instanciranjem podrazreda izberemo želeno selekcijo.
		 
		@author Aleš Zamuda
		*/
		class Selection {
		public:
			Selection(Populacija *populacija);
			virtual ~Selection()=0;

			virtual void selekcija(Osebek **oce, Osebek **mati, std::vector<Osebek*> *osebki)=0;

			virtual void shraniBitsInEval(
					const std::vector<bool> &bestBits,
					float bestEval);
			virtual void printSelectionStats();
		protected:
			Populacija *populacija;
			std::vector<bool> bestBits;
			float bestEval;
		};
	}
}

#endif
