/***************************************************************************
 *   Copyright (C) 2005 by Aleš Zamuda   *
 *   ales.zamuda@uni-mb.si   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "selectionproportional.h"
#include "osebek.h"
#include "populacija.h"
#include <iostream>

namespace genetic {

	namespace selection {

		SelectionProportional::SelectionProportional(Populacija *populacija)
				: Selection(populacija) {}

		SelectionProportional::~SelectionProportional() {}

		Osebek* SelectionProportional::proporcionalnaSelekcija(float r,
				std::vector<Osebek*> *osebki) {
			float ac=0;
			for (int i = 0; i < populacija->getPop_size(); i++) {
				ac+=(*osebki)[i]->ocena/populacija->getLastF();
				if (ac>=r) return (*osebki)[i];
			}
			return (*osebki)[populacija->getPop_size()-1];//sicer vrnemo zadnjega
		}

		//"""Po pravilih selekcije določi očeta in mater za naslednjo generacijo."""
		void SelectionProportional::selekcija(Osebek **oce, Osebek **mati,
											  std::vector<Osebek*> *osebki) {
			float r1=(float)rand()/RAND_MAX;
			*oce=proporcionalnaSelekcija(r1, osebki);
			float r2=(float)rand()/RAND_MAX;
			*mati=proporcionalnaSelekcija(r2, osebki);

			assert(*oce && *mati);
			if (populacija->izpisujSelekcije)
				std::cerr << "Križam " << (*oce)->id << "+"<< (*mati)->id << ". "<<std::endl;
		}
	}
}
