/***************************************************************************
 *   Copyright (C) 2005 by Aleš Zamuda   *
 *   ales.zamuda@uni-mb.si   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GENETIC_SELECTIONSELECTIONPROPORTIONAL_H
#define GENETIC_SELECTIONSELECTIONPROPORTIONAL_H

#include <selection.h>

namespace genetic {

	namespace selection {

		/**
		Osebke izbira s proporcionalno selekcijo.
		Osebek je izbran glede na razmerje med njegovo ocenitvijo in vsoto ocenitev vseh osebkov
		v populaciji trenutne generacije.
		 
		@author Aleš Zamuda
		*/
		class SelectionProportional : public Selection {
		public:
			SelectionProportional(Populacija *populacija);
			~SelectionProportional();
			virtual void selekcija(Osebek **oce, Osebek **mati, std::vector<Osebek*> *osebki);
			
		private:
			Osebek* proporcionalnaSelekcija(float r, std::vector<Osebek*> *osebki);
		};

	}

}

#endif
