/***************************************************************************
 *   Copyright (C) 2005 by Aleš Zamuda   *
 *   ales.zamuda@uni-mb.si   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "selectiontournament.h"
#include "osebek.h"
#include "populacija.h"
#include <iostream>

namespace genetic {

	namespace selection {

		SelectionTournament::SelectionTournament(Populacija *populacija)
				: Selection(populacija) {
			k=2;
		}

		SelectionTournament::~SelectionTournament() {}

		Osebek* SelectionTournament::turnirskaSelekcija(std::vector<Osebek*> *osebki) {
			float r1=(float)rand()/RAND_MAX;
			int index=(int)(populacija->getPop_size()*r1);;
			float maxOcena=(*osebki)[index]->ocena;

			//trenutni naj tekmuje še z ostalimi
			for (int i = 0; i < k-1; i++) {
				float r=(float)rand()/RAND_MAX;
				int ind=(int)(populacija->getPop_size()*r);
				if ((*osebki)[ind]->ocena > maxOcena)
					index=ind;
			}
			return (*osebki)[index];
		}

		void SelectionTournament::SelectionTournament::selekcija(Osebek **oce, Osebek **mati,
		        std::vector<Osebek*> *osebki) {
			*oce=turnirskaSelekcija(osebki);
			*mati=turnirskaSelekcija(osebki);

			assert(*oce && *mati);
			if (populacija->izpisujSelekcije)
				std::cerr << "Križam " << (*oce)->id << "+"<< (*mati)->id << ". "<<std::endl;
		}
	}
}
